//Copyright 2009 Chris Glasier

/*
A device using nameset interface technology to create/edit/review Sketchup scenes
Follows standard nameset for later integration
*/

/* 
Release 1.0 - Basic configuration
Release 1.01 - Revisions
	
# 	Added sketchup.rb (thanks to Tomasz SCF)
#	Add new scene setup for new files
>>	Right aligned menu
# 	Rename layer
#	Excluded Layer0


Release 1.02 - Revisions

aspects = Properties to be saved, Layers, Components, Views and Styles

Use cgScenes left column to browse (1st click) and (2nd click) open scene and current aspect
Use cgScenes middle column to open aspects for current scene
Use cg Scenes middle column layer menu to sort layers by abc or visibility and to add and name new layer
Use cg Scenes middle column components menu to show or hide all current scene components (pending)
Use cgScenes right column to browse (1st click) and (2nd click) hide/show properties to save,layers and components, and change views and styles.

Use SU context menu to add, delete, rename or describe a scene
Use SU layers to rename or delete existing layer
Use SU layers to select layer colours
Use SU shadows toolbar

*/
/*

Release 1.03*

skp functions renamed according to DeviceNameAction (DNA!) - e.g. sceneLayersAdd
Auto refresh when returning focus to dialog
Vacated menupanels for Nameset menus
Added device menu panel
Disabled testing floating text
White colour option
JS annotation
Added collections and groupings pending note
Added skpSwitch for testing HTML on non IE browsers
Removed IE only syntax
Added input element for renaming new layer

*/

panelWidth = 230		//suggested
panelHeight = 345		//suggested
cellHeight = 20			//reccommended standard
columns 	= 3			// for this device functionality
stripeTop = 5			//rows from top

skpSwitch = 1			//for testing as standalone

trialList = "One,Two,Three"


/////FIXED LISTS; LAYERS,COMPOENTS,STYLES FROM MODEL DATA
// genericName,givenName,visibility(font colour)

aspectArray = new Array()
aspectArray.push(new Array("Properties","Property","true"))
aspectArray.push(new Array("Layers","Layer","true"))
aspectArray.push(new Array("Collections","Collection","true"))
aspectArray.push(new Array("Groupings","Grouping","true"))
aspectArray.push(new Array("Components","Component","true"))
aspectArray.push(new Array("Styles","Style","true"))
aspectArray.push(new Array("Views","View","true"))

viewsArray = new Array()
viewsArray.push(new Array("View","Top","true"))
viewsArray.push(new Array("View","Bottom","true"))
viewsArray.push(new Array("View","Front","true"))
viewsArray.push(new Array("View","Back","true"))
viewsArray.push(new Array("View","Left","true"))
viewsArray.push(new Array("View","Right","true"))
viewsArray.push(new Array("View","Isometric","true"))
viewsArray.push(new Array("View","ZoomExtents","true"))
viewsArray.push(new Array("View","Perspective","true"))



//FOR FILES WITH NO SCENES



newScenes = new Array("3d","Ortho","Trade")



//TEMPORARY NAMESET INTEGRATION SOLUTION




function menu1Down(e){}
function menu2Down(e){}




/////FUNCTION CALL FROM HTML FILE




function start(){

//TO REFRESH cgSCENES AFTER WORKING IN SU DISPLAY

window.onfocus = sceneEnter
window.onblur = sceneExit

//TO FIND IF ANY SCENES EXIST

window.location = "skp:sceneCount"  

//ADD SCENES

if(count == 0 ){
list = newScenes
for(a=0; a<list.length; a++){
window.location = "skp:sceneScenesAdd@"+list[a]  }   }

sceneSet()
sceneFirst()
sceneRun()  }




//////RETURNING FROM SKETCHUP DISPLAY -onfocus



enterNo = 0



function sceneEnter(){
if(enterNo == 1){
confirmPanel.style.display ="none"
window.location = "skp:sceneUpdate" 
sceneRefresh()
sceneUpdater()
enterNo = 0  }   }




function sceneExit(){
enterNo = 1  }




/////RESIZING



function receiveSceneCount(x){
count = x    }


function sceneResize(){
panelWidth = document.body.clientWidth
panelHeight = document.body.clientHeight
cellWidth = Math.floor(panelWidth/columns)
rows = Math.floor(panelHeight/cellHeight)
sceneRun() 
eval("sceneRun"+sceneAspect)()     }



///// INITIALISE


function sceneSet(){

if(skpSwitch == 1) dialogSize()

scenePanelNames()

layerSort = "abc"

componentSort = "none"

confirmPanel.style.display = "none"

sceneAspect = "Properties"

sliderTops = new Array(0,0,0)

//FOR MENUS ...

commander = "Scenes"  }




////INITIAL DIALOG SIZE



function dialogSize(){

w = panelWidth+6
h = panelHeight+30

cellWidth = Math.floor(panelWidth/columns)
rows = Math.floor(panelHeight/cellHeight)

params = new Array(w,h)

params = params.join(",")
window.location = "skp:coreSet_size@"+ params   }



///// PANEL NAMES



function scenePanelNames(){
copyPanel = document.getElementById("copy")
namePanel = document.getElementById("name")
devicePanel = document.getElementById("device")
confirmPanel = document.getElementById("confirm")
menuPanel1 = document.getElementById("menu1")
menuPanel2 = document.getElementById("menu2")   }




///// CURRENT SCENE



function receiveFirstScene(x){
ind = x    }


function sceneFirst(){

window.location = "skp:sceneScenesFirst"

//ind from receiveScenes

sliderTops[0] = ind

params = new Array(ind)
params = params.join(",")
window.location = "skp:sceneSceneSelected@"+params    }



/////MAIN RUNNER


function sceneRun(){


//CLEARS EVERYTHING

devicePanel.innerHTML = ""

//REMAKES DEVICE PANELS 

sceneSetDeviceHolder()
sceneSetDeviceMenu()
sceneStripe()
sceneColumnSliders()
scenePanelSizes()

//REMAKES SCENES LIST + ASPECT LIST

sceneRunScenes()
sceneRunAspects()    }




/////DEVICE COMPONENT PANELS - NORMALLY OVERLAYS NAMESET



function sceneSetDeviceHolder(){
obj = document.createElement("div")
devicePanel.appendChild(obj)
obj.id = "holder"
deviceHolder = document.getElementById("holder")
with(deviceHolder){
className = "device"
with(style){
top = 0
width = panelWidth
height = panelHeight 
   }  }  }


function sceneSetDeviceMenu(){
obj = document.createElement("div")
devicePanel.appendChild(obj)
obj.id = "dmenu"
deviceMenu = document.getElementById("dmenu")
with(deviceMenu){
className = "deviceMenu"
with(style){
top=0
width =panelWidth
height = cellHeight  }  }  }



function sceneStripe(){
obj = document.createElement("div")
deviceHolder.appendChild(obj)
with(obj){
id  = "stripe"
className = "stripe"
with(style){
left = 0
top = stripeTop * cellHeight
width = columns * cellWidth
height = cellHeight  } }  }


function sceneColumnSliders(){

bLeft = 0
for(a=0; a<columns; a++){
sceneColumnSlider() }  } 


function sceneColumnSlider(){
obj = document.createElement("div")
deviceHolder.appendChild(obj)
with(obj){
colNo = a
id  = "sc"+ colNo 
with(style){
theTop = stripeTop-eval(sliderTops[a])
top = theTop*cellHeight   }  }   }



//ADJUSTS HTML FILE DIVS



function scenePanelSizes(){

with(namePanel){
with(style){
left 	= 0
top 	= 2 * cellHeight  } }

with(devicePanel){
with(style){
left = 0
top = 2 * cellHeight}}

with(confirmPanel){
innerHTML = "UPDATE"
with(style){
left = panelWidth-cellWidth
top = 0   
width = cellWidth  }}


with(menuPanel1){
className = "device"
with(style){
left = 0
top = 0 
width = panelWidth
height = cellHeight  }  }

with(menuPanel2){
className = "device"
with(style){
left = 0
top = cellHeight
width = panelWidth
height = cellHeight }  } 

with(copyPanel){
innerHTML = "&copy;Chris Glasier 2008/9"
className = "copy"
with(style){
left = 0
top = 0
width = panelWidth }  } 

//SLIDERS LEFTS

bLeft = 0
for(a=0; a<columns; a++){
with(document.getElementById("sc"+a).style){
left = bLeft
width = bLeft * cellWidth   }
bLeft = bLeft += cellWidth    }   }



/////SCENES



function receiveScenes(x){
scenesString = x    }


function sceneRunScenes(){

window.location = "skp:sceneScenesFind"


//from receiveScenes


list = scenesString.split(";")

sceneArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")

thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Scenes"
entry[1] = thisName
entry[2] = "true"

sceneArray.push(entry)  } 

childNos = sceneArray
colNo = 0
sceneRunChildren()  }



/////ASPECTS


function sceneRunAspects(){
childNos = aspectArray
colNo = 1
sceneRunChildren()  }



/////PROPERTIES


function receiveProperties(x){
propertiesString = x    }

function sceneRunProperties(){
window.location = "skp:scenePropertiesFind"

// from receiveLayers
list = propertiesString.split(";")

propertiesArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Property"
entry[1] = thisName
entry[2] = couplet[1]

propertiesArray.push(entry)  } 

childNos = propertiesArray
colNo = 2
sceneRunChildren() }




/////LAYERS



function receiveLayers(x){
layersString = x    }


function sceneRunLayers(){

window.location = "skp:sceneLayersFind"

// from receiveLayers


list = layersString.split(";")
list.sort()


//VISIBILITY SPLITTER


if(layerSort == "vis"){
visArray = new Array()
invArray = new Array()

for(a=0; a<list.length; a++){
list[a]=list[a].split(",")

if(list[a][1] == "true") visArray.push(list[a].join(","))


else invArray.push(list[a].join(","))}
list = visArray.concat(invArray)   }

layersArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

//Layer0 not editable in cgScenes

if(thisName == "Layer0") continue

entry = new Array()
entry[0] = "Layer"
entry[1] = thisName
entry[2] = couplet[1]
entry[3] = couplet[2]

layersArray.push(entry)  } 

childNos = layersArray
colNo = 2
sceneRunChildren()  }



/////COMPONENTS



function receiveComponents(x){
componentsString = x    }

cnt = 0

function sceneRunComponents(){

window.location = "skp:sceneComponentsFind"

// from receiveComponents


list = componentsString.split(";")
list.sort()

cnt++
componentsArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

if(componentSort == "show") couplet[1] = "false" //all show
if(componentSort == "hide") couplet[1] = "true"  // all hide

//otherwise uses SU data

entry = new Array()
entry[0] = "Component"
entry[1] = thisName
couplet[1]=="false"? entry[2] = "true" : entry[2] = "false"
entry[3] = couplet[2]

componentsArray.push(entry)  } 

childNos = componentsArray
colNo = 2
sceneRunChildren()   }


/////COLLECTIONS & COMPONENTS



function sceneRunCollections(){}

function sceneRunGroupings(){}



/////STYLES


function receiveStyles(x){
stylesString = x    }


function receiveSceneStyle(y){
sceneStyle = y     }


function sceneRunStyles(){

window.location = "skp:sceneScenesStyle"
stylesArray = new Array()


window.location = "skp:sceneStylesFind"



// from receiveLayers


list = stylesString.split(";")
list.sort()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")

if(couplet[0] == sceneStyle) activeRow = a
sliderTops[2] = activeRow

thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Style"
entry[1] = thisName
entry[2] ="true"
entry[3] = couplet[1]
stylesArray.push(entry)  } 

childNos = stylesArray
colNo = 2
sceneRunChildren()


//ONLY ADJUST SLIDER FOR STYLES - SCENE STYLE IS KNOWN


//sceneAdjustSlider()

colNo = 1  }



function sceneRunViews(){
childNos = viewsArray
colNo = 2
sceneRunChildren()  }


//RUN OFF


function sceneRunChildren(){
document.getElementById("sc"+ colNo).innerHTML = ""
bTop = 0

for(c=0; c<childNos.length; c++){

genericName = childNos[c][0]
givenName = childNos[c][1]


//cind = SU ENTITY INDEX

childNos[c][2] == "false"? theClass = "off" : theClass = "on"
childNos[c][3] == undefined? cind = 0 : cind = childNos[c][3]


obj = document.createElement("div")
document.getElementById("sc"+ colNo).appendChild(obj)

with(obj){
id = new Array(genericName,colNo,c,cind)
innerHTML = givenName
title = id			//for testing
className = theClass 


with(style){
left = 0
top = bTop 
width = cellWidth
height = cellHeight   }   }
bTop+= cellHeight    }   }




//EVENTS IN COLUMNS



counter = 0
lastCell = undefined

function findTarget(e){
var targ;
if (!e) {var e = window.event }
if (e.target){ targ = e.target;  }
else if (e.srcElement){  targ = e.srcElement;  }

thisCell = targ  }



function deviceDown(e){

findTarget()
if(thisCell.id == "holder" ) return
if(thisCell.id == "dmenu" ) return

if(thisCell.tagName == "INPUT") return

//DEVICE MENUS

if(thisCell.parentElement.id == "dmenu"){

try{deviceMenuDown() }
catch(e){}
 return }
 
 
 
//ONE CLICK TO NAVIGATE; SECOND CLICK ON SAME CELL TO ACTION
 
 
 
thisCell == lastCell? counter = 1 : counter = 0
lastCell = thisCell

sceneCellId = thisCell.id.split(",")
genericName = sceneCellId[0]
commander = genericName

colNo = sceneCellId[1]
activeRow = sceneCellId[2]
cind = sceneCellId[3]

sceneAdjustSlider()

eval("scene"+colNo+"Down")()    }



/////SLIDER


function sceneAdjustSlider(){

slider = document.getElementById("sc"+ colNo)
startTop = slider.style.top.slice(0,-2)

cTop = activeRow-stripeTop

finishTop = -cTop*cellHeight
sceneSlideStop = setInterval(sceneSlide,5)   }


function sceneSlide(){
theTop = slider.style.top.slice(0,-2)

if(theTop == finishTop){
clearInterval(sceneSlideStop)


// ADJUSTS THE POSITION BECAUSE CURRENT STYLE IS KNOWN


if(genericName == "Style"){
colNo = 2
sceneAdjustSlider()   }   }

else{

eval(startTop)-finishTop > 0? x = -1 :x = 1

theTop = slider.style.top.slice(0,-2)

theTop = eval(theTop)+x*5

slider.style.top = theTop+"px"    }   }



/////FIRST COLUMN


function scene0Down(){
sliderTops[0] = activeRow

if(counter == 1){

//OPENS SCENE

params = activeRow
window.location = "skp:sceneSceneSelected@"+params

//CLEARS MENU

menuList = ""
sceneDeviceMenuList()     

eval("sceneRun"+sceneAspect)()    }

else{

document.getElementById("sc"+2).innerHTML =""
 
menuList = "Again to confirm"

sceneDeviceMenuList()
deviceMenu.style.textAlign = "left"   }  }



//SECOND COLUMN



function scene1Down(){

sliderTops[1] = activeRow

document.getElementById("sc2").innerHTML = ""

//document.getElementById("sc2").style.top = stripeTop*cellHeight

sceneAspect = genericName

menuList = eval("scene"+sceneAspect+"List")
sceneDeviceMenuList()
deviceMenu.style.textAlign = "center"

eval("sceneRun"+genericName)()    }


//THIRD COLUMN


function scene2Down(){

sliderTops[2]= activeRow

menuList = ""
sceneDeviceMenuList()  
deviceMenu.style.textAlign = "right"

eval("sceneTools"+genericName)()  }



//ACTIONS FROM EVENTS IN COLUMNS



function sceneToolsProperty(){

if(counter==1) sceneLayerToggle()
else{
menuList = "Again to toggle"
sceneDeviceMenuList()   }  }


function sceneToolsLayer(){

if(counter==1) sceneLayerToggle()


else{


//INPUT CELL FROM LAYERS ADD/RENAME


if(thisCell.tagName =="INPUT") menuList = ""


else {

menuList = "Again to toggle"
sceneDeviceMenuList()   }  }   }


function sceneToolsComponent(){
if(counter==1) sceneComponentToggle()
else{
menuList = "Again to toggle"
sceneDeviceMenuList()

//HIGHLIGHTS BOUNDING BOX

window.location = "skp:sceneHiliteClear"
window.location = "skp:sceneHiliteOn@"+cind  } }


function sceneToolsView(){
if(counter==1){
word = thisCell.innerHTML
window.location = "skp:sceneView"+word 

//CHANGES SU DISPLAY DIRECTLY - REQUIRES UPDATE TO SAVE


sceneUpdater()  }


else{
menuList = "Again to toggle"
sceneDeviceMenuList()   }  }

function sceneToolsStyle(){
if(counter==1){
window.location = "skp:sceneStyleUse@"+cind


//CHANGES SU DISPLAY DIRECTLY - REQUIRES UPDATE TO SAVE


sceneUpdater()   }
else{
menuList = "Again to toggle"
sceneDeviceMenuList()  }   }




//MENUS AND ACTIONS



scenePropertiesList = "Properties to save"
sceneLayersList = "Abc,Visibility,Add"
sceneComponentsList = "Pending"

//For Release 2 series

sceneCollectionsList = "Will allow selection of collection names"
sceneGroupingsList = "Will allow selection of grouping names"

sceneComponentsList = "Show_all,Hide_all"
sceneViewsList = "Orthogonal views"
sceneStylesList = "Styles in model"


function sceneDeviceMenuList(){
deviceMenu.innerHTML = ""

list = menuList.split(",")
for(a=0; a<list.length; a++){


obj = document.createElement("a")
deviceMenu.appendChild(obj)


with(obj){
innerHTML = list[a]
className = "menu" }  }  }



function deviceMenuDown(e){
findTarget()
menuCell = thisCell
menuName =  menuCell.innerHTML.split(" ").join("")
menuPanel = deviceMenu

try{eval("scene"+commander+menuName)()   }
catch(e){  }  }



function sceneLayersAbc(){
layerSort = "abc"
sliderTops[2] = 0
sceneRefresh() }


function sceneLayersVisibility(){
layerSort = "vis"
sliderTops[2] = 0
sceneRefresh() }


function sceneLayersAdd(){
window.location = "skp:sceneLayersAdd" 
sliderTops[2] = 0
sceneRefresh()


//ONLY FOR NEW NAMES; OTHER RENAMING IN SU LAYER WINDOW


sceneLayerRename()  }


function sceneComponentsShow_all(){
componentSort = "show"
sceneRefresh()
params = "Show"

//CHANGES SU DISPLAY

window.location = "skp:sceneComponentsToggleAll@"+params 


//RETURNS TO DEFAULT


componentSort = "none" 



//UPDATER



sceneUpdater()  }


function sceneComponentsHide_all(){
componentSort = "hide"
sceneRefresh()

params = "Hide"

//CHANGES SU DISPLAY

window.location = "skp:sceneComponentsToggleAll@"+params


//RETURNS TO DEFAULT


componentSort = "none" 



//UPDATER


sceneUpdater()  }


function scenePropertyToggle(){

//CHANGES SU DISPLAY

fileName = "scenePropertyToggle"+thisCell.innerHTML+thisCell.className
window.location = "skp:"+fileName

//CHANGES FONT COLOUR

thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl

//CHANGES SU DISPLAY DIRECTLY - REQUIRES UPDATE TO SAVE

sceneUpdater() }


function sceneLayerRename(){

newCell = document.getElementById("sc"+2).firstChild

transferName = newCell.innerHTML
newCell.innerHTML = ""


obj = document.createElement("input")
newCell.appendChild(obj)


with(obj){

id = "transferBox"
value = transferName


with(style){

width =cellWidth
height = cellHeight

backgroundColor = "pink"   }   }

sceneUpdater()          }


function sceneLayerToggle(){


fileName = "sceneLayerToggle"+thisCell.className
window.location = "skp:"+fileName+"@"+cind


thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl


sceneUpdater() }


function sceneComponentToggle(){
fileName = "sceneComponentToggle"+thisCell.className
window.location = "skp:"+fileName+"@"+cind


thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl


sceneUpdater()	 }




//SCENE UPDATER



function sceneUpdater(){
confirmPanel.style.display ="block" 	}

//Updater is in confirm block



function confirmDown(e){

confirmPanel.style.display ="none"
window.location = "skp:sceneUpdate" 


coll = document.getElementById("sc2").childNodes

if(coll[0].firstChild.tagName == "INPUT"){

//SU SORTS BY CAPITALISED WORDS FIRST

newName = document.getElementById("transferBox").value
newName = newName.charAt(0).toUpperCase()+newName.substr(1).toLowerCase()


params = new Array(newName)
params = params.join(",")

window.location = "skp:sceneLayersRename@"+params
sceneRefresh()   }   }




//SCENE REFRESH



function sceneRefresh(){

sceneFirst()

sceneRun() 

eval("sceneRun"+sceneAspect)()     }

